/*
 * Simple Bike Map showing all Cycle Hire stations.
 *
 * Created for Unfolding workshop at RCA.
 * (c) 2014 Till Nagel, tillnagel.com
 */ 
import de.fhpotsdam.unfolding.*;
import de.fhpotsdam.unfolding.geo.*;
import de.fhpotsdam.unfolding.utils.*;

UnfoldingMap map;

ArrayList<Location> locations = new ArrayList();

void setup() {
  size(800, 600, P2D);

  map = new UnfoldingMap(this);
  map.zoomAndPanTo(new Location(51.500, -0.118), 12);
  MapUtils.createDefaultEventDispatcher(this, map);

  Table bikeData = loadTable("http://api.bike-stats.co.uk/service/rest/bikestats?format=csv", "header, csv");
  for (TableRow bikeStationData : bikeData.rows()) {
    int id = bikeStationData.getInt("ID");
    String name = bikeStationData.getString("Name");
    int bikesAvailable = bikeStationData.getInt("BikesAvailable");
    float lat = bikeStationData.getFloat("Latitude");
    float lng = bikeStationData.getFloat("Longitude");
    Location location = new Location(lat, lng);
    println(name + " (" + id + ") has " + bikesAvailable + " bikes available.");
    locations.add(location);
  }
}

void draw() {
  map.draw();
  
  for (Location location : locations) {
    ScreenPosition pos = map.getScreenPosition(location);
    ellipse(pos.x, pos.y, 5, 5);
  }
}

